// Java class org.ethereum.geth.BoundContract is a proxy for talking to a Go program.
//   gobind -lang=java -javapkg=org.ethereum github.com/ethereum/go-ethereum/mobile
//
// File is generated by gobind. Do not edit.
package org.ethereum.geth;

import go.Seq;

/**
 * BoundContract is the base wrapper object that reflects a contract on the
Ethereum network. It contains a collection of methods that are used by the
higher level contract bindings to operate.
 */
public final class BoundContract implements Seq.Proxy {
	static { Geth.touch(); }
	
	private final int refnum;
	
	@Override public final int incRefnum() {
	      Seq.incGoRef(refnum, this);
	      return refnum;
	}
	
	BoundContract(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
	
	public BoundContract() { this.refnum = __New(); Seq.trackGoRef(refnum, this); }
	
	private static native int __New();
	
	/**
	 * Call invokes the (constant) contract method with params as input values and
	sets the output to result.
	 */
	public native void call(CallOpts opts, Interfaces out, String method, Interfaces args) throws Exception;
	public native Address getAddress();
	public native Transaction getDeployer();
	/**
	 * Transact invokes the (paid) contract method with params as input values.
	 */
	public native Transaction transact(TransactOpts opts, String method, Interfaces args) throws Exception;
	/**
	 * Transfer initiates a plain transaction to move funds to the contract, calling
	its default method if one is available.
	 */
	public native Transaction transfer(TransactOpts opts) throws Exception;
	@Override public boolean equals(Object o) {
		if (o == null || !(o instanceof BoundContract)) {
		    return false;
		}
		BoundContract that = (BoundContract)o;
		return true;
	}
	
	@Override public int hashCode() {
	    return java.util.Arrays.hashCode(new Object[] {});
	}
	
	@Override public String toString() {
		StringBuilder b = new StringBuilder();
		b.append("BoundContract").append("{");
		return b.append("}").toString();
	}
}

