// Java class org.ethereum.geth.Receipt is a proxy for talking to a Go program.
//   gobind -lang=java -javapkg=org.ethereum github.com/ethereum/go-ethereum/mobile
//
// File is generated by gobind. Do not edit.
package org.ethereum.geth;

import go.Seq;

/**
 * Receipt represents the results of a transaction.
 */
public final class Receipt implements Seq.Proxy {
	static { Geth.touch(); }
	
	private final int refnum;
	
	@Override public final int incRefnum() {
	      Seq.incGoRef(refnum, this);
	      return refnum;
	}
	
	/**
	 * NewReceiptFromJSON parses a transaction receipt from a JSON data dump.
	 */
	public Receipt(String data) {
		this.refnum = __NewReceiptFromJSON(data);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewReceiptFromJSON(String data);
	
	/**
	 * NewReceiptFromRLP parses a transaction receipt from an RLP data dump.
	 */
	public Receipt(byte[] data) {
		this.refnum = __NewReceiptFromRLP(data);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewReceiptFromRLP(byte[] data);
	
	Receipt(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
	
	/**
	 * EncodeJSON encodes a transaction receipt into a JSON data dump.
	 */
	public native String encodeJSON() throws Exception;
	/**
	 * EncodeRLP encodes a transaction receipt into an RLP data dump.
	 */
	public native byte[] encodeRLP() throws Exception;
	public native Bloom getBloom();
	public native Address getContractAddress();
	public native long getCumulativeGasUsed();
	public native long getGasUsed();
	public native Logs getLogs();
	public native byte[] getPostState();
	public native long getStatus();
	public native Hash getTxHash();
	@Override public boolean equals(Object o) {
		if (o == null || !(o instanceof Receipt)) {
		    return false;
		}
		Receipt that = (Receipt)o;
		return true;
	}
	
	@Override public int hashCode() {
	    return java.util.Arrays.hashCode(new Object[] {});
	}
	
	@Override public String toString() {
		StringBuilder b = new StringBuilder();
		b.append("Receipt").append("{");
		return b.append("}").toString();
	}
}

